package cz.jzitnik.game.handlers.rightclick;

import cz.jzitnik.game.Block;
import cz.jzitnik.game.Game;
import cz.jzitnik.game.handlers.place.handlers.DoorPlaceHandler;
import cz.jzitnik.game.ui.Window;
import cz.jzitnik.tui.ScreenRenderer;

import java.util.HashMap;

public class RightClickHandler {
    @FunctionalInterface
    public interface Function3<T, U> {
        void apply(T t, U u);
    }

    public static void handle(int x, int y, Game game, ScreenRenderer screenRenderer) {
        if (game.isMining()) {
            return;
        }

        HashMap<String, Function3<Integer, Integer>> functionMap = new HashMap<>();
        functionMap.put("crafting_table", game.getGameStates().craftingTable::render);
        functionMap.put("chest", (Integer ignored, Integer ignored2) -> game.setWindow(Window.CHEST));
        functionMap.put("furnace", (Integer ignored, Integer ignored2) -> game.setWindow(Window.FURNACE));
        functionMap.put("oak_door", (Integer xx, Integer xy) -> DoorPlaceHandler.rightClick(game, xx, xy, screenRenderer));

        game.getGameStates().clickX = x;
        game.getGameStates().clickY = y;

        var blocks = game.getWorld()[y][x];
        for (Block block : blocks) {
            if (functionMap.containsKey(block.getBlockId())) {
                functionMap.get(block.getBlockId()).apply(x, y);

                return;
            }
        }
    }
}
